

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#include "simpleio.h"

#pragma code-name ("RW_BSTK")

extern unsigned char c, *curmptr, CurPos;
#pragma zpsym ("c")
#pragma zpsym ("curmptr")
#pragma zpsym ("CurPos")

//This file was taken from AltInput.  It is a copy of the file in cbmsimpio\.
//AltInput is available in https://sourceforge.net/projects/cc65extra/files/ui/.
unsigned char __fastcall__ GetInput (char* In, char InLen)
{
	//static unsigned char c;		//Current char.
	//static unsigned char CurPos;	//Current pos./len. in buffer
	CurPos=0;
	curmptr=In;
	//Prompt.  If you desire a different prompt, print it
	//here.
	//printc ('>');
	//Main loop:
	while (1)
	{
		//Emulate cursor and get key.
		//CBMSimpleIO doesn't have cursor support.
		printc ('_');
		c = getkey ();
		printc ('\b');

		//Process the key.
		if (c=='\n'){ /*return*/
			curmptr[CurPos]=0;		//Terminate input string.
			printcr ();		//Go to next screen line.
			return CurPos+1;		//Return string len.
		} if (c == '\b' && CurPos > 0) { /* delete */
			//Won't be processed if the buffer is empty.
			--CurPos;		//Cursor left.
			printc ('\b');		//Delete last char. from screen.
		} if ((c&0x60) && CurPos<InLen) { //Printable char.
			curmptr[CurPos]=c;		//Add key to buffer and advance.
			++CurPos;
			printc (c);
		}
	}
}

